// include only avr libraries
#include <avr/io.h>
#include <util/delay.h>

#define BUS_MASK 0x0F

// message to send
uint8_t mts[] = {'H','e','l','l','o',' ','w','o','r','l','d','!'}; //12 x 2 sym
const uint8_t msg_len = 24; //in symbols
uint8_t wi = 0;  //write index

void setup() {
  PORTD &= ~_BV(PORTD4);    // clear data ready
  PORTB &= ~BUS_MASK;       // clear the bus
  DDRD |= _BV(DDD4);        // DATA_READY at PD4
  DDRB |= BUS_MASK;         // our bus at PB0 to PB3
  DDRB |= _BV(DDB5);        // use the LED on PB5
}

void loop() {
  send_function();
  _delay_ms(400); // to see the different transfers on blink
}

// the function to send symbols...
void send_function() {
  if(wi<msg_len){
    uint8_t mi = wi >> 1;
    uint8_t stw = (wi % 2 == 0) ? mts[mi] : mts[mi] >> 4; // local var symbol
    PORTB &= ~BUS_MASK;      // clear the bus
    PORTB |= stw & BUS_MASK; // write the symbol
    _delay_ms(5);
    PORTD |= _BV(PORTD4);    // signal data ready
  
    //short blink on led
    PORTB |= _BV(PORTB5);
    _delay_ms(50);
    PORTB &= ~_BV(PORTB5);
    _delay_ms(50);
  
    wi++;                     // increment write index
    PORTD &= ~_BV(PORTD4);    // clear data ready
  }
}


