// include only avr libraries
#include <avr/io.h>
#include <util/delay.h>

#define BUS_MASK 0x0F

// message to send
uint8_t mts[] = {'H','e','l','l','o',' ','w','o','r','l','d','!'}; //12 x 2 sym
const uint8_t msg_len = 24; //in symbols
uint8_t wi = 0;  //write index

void setup() {
  pinMode(4, OUTPUT);
  pinMode(8, OUTPUT); pinMode(9, OUTPUT);pinMode(10, OUTPUT);pinMode(11, OUTPUT);
  pinMode(13, OUTPUT);
  digitalWrite(4, LOW);
  PORTB &= ~BUS_MASK; //clear the bus
  // digitalWrite(8, LOW); digitalWrite(9, LOW); digitalWrite(10, LOW); digitalWrite(11, LOW); 
}

void loop() {
  send_function();
  delay(400); // to see the different transfers on blink
}

// the function to send symbols...
void send_function() {
  if(wi<msg_len){
    uint8_t mi = wi >> 1;
    uint8_t stw = (wi % 2 == 0) ? mts[mi] : mts[mi] >> 4; //local var symbol
    PORTB &= ~BUS_MASK; //clear the bus
    PORTB |= stw & BUS_MASK; //write the symbol
    delay(5);
    digitalWrite(4, HIGH);
  
    //short blink on led
    digitalWrite(13, HIGH); delay(50); digitalWrite(13, LOW); delay(50);
  
    wi++;                     //increment write index
    digitalWrite(4, LOW);
  }
}


