#include "Wire.h"
#define PCF8574_ADDRESS 0x20
#define PCF8574_LED 0     // bit 0
#define PCF8574_MOTOR 1   // bit 1

uint8_t remote_port_status = 0x00;

void setup()
{
  Wire.begin();
  Serial.begin(115200);
  setPorts();
}
void setPorts(){
  Wire.beginTransmission(PCF8574_ADDRESS);
  Wire.write(remote_port_status); 
  Wire.endTransmission();
}

void port_ON(uint8_t led_motor){
  remote_port_status |= _BV(led_motor);
  setPorts();
}
void port_OFF(uint8_t led_motor){
  remote_port_status &= ~_BV(led_motor);
  setPorts();
}

void loop(){
  uint8_t command = 0;
  while(!Serial.available());
  command = Serial.read();
  switch(command){
    case '1':
      port_ON(PCF8574_LED); break;
    case '0':
      port_OFF(PCF8574_LED); break;
    case 'm':
      port_ON(PCF8574_MOTOR); break;
    case 's':
      port_OFF(PCF8574_MOTOR); break;
  }
  delay(500);
}
